/*
 * ap-carray.h
 * $Id: ap-carray.h,v 1.1.1.1 2004/02/14 04:30:12 arim Exp $
 */

#ifndef INCLUDED_AP_CARRAY
#define INCLUDED_AP_CARRAY

/******************************************************************
 * Macros
 ******************************************************************/

/******************************************************************
 * Types
 ******************************************************************/

typedef struct _charray {
  char *val;  /* array of chars */
  int  len;   /* the length of the array */
  int  maxlen; /* the length of the allocated array */
} *Charray;
 
/* Note: Intarray is a pointer to a struct. */

/******************************************************************
 * Functions
 ******************************************************************/
extern Charray ca_alloc(int len);
extern void ca_free(Charray temp);
extern void ca_make_null(Charray tmp); 
extern void ca_realloc(Charray ca, int size); 
extern void ca_append(Charray ca, Charray da); 
extern void ca_copy(Charray ca, Charray cb); 
extern void ca_copy_org(Charray ca, Charray cb); 
extern void ca_push_back(Charray ca, char c); 
extern void push_back(Charray ca, char c); 
extern char ca_pop(Charray ca); 
extern void ca_print(Charray ca);
extern void ca_print_nl(); 
extern char printable_char(char c); 
extern void ca_report(Charray ca); 
extern void ca_int_print(Charray ca); 
extern void ca_int_report(Charray ca); 
extern int ca_write_disk(Charray ca, char *outname); 
extern int ca_read_disk(Charray ca, char *inname); 
extern int ca_veryfy_disk(Charray ca, char *file_name); 
extern Charray ca_append_str(Charray ca, char *str); 
extern Charray ca_copy_str(Charray ca, char *str); 
extern void ca_write_to_str(Charray ca, char *str, int len); 

/******************************************************************
 * Comments
 ******************************************************************/

#endif

