/*
 * ap-iarray.h
 * $Id: ap-iarray.h,v 1.2 2004/02/25 19:19:54 arim Exp $
 */

#ifndef INCLUDED_AP_IARRAY
#define INCLUDED_AP_IARRAY

/******************************************************************
 * Macros
 ******************************************************************/

/******************************************************************
 * Types
 ******************************************************************/

typedef 
struct intarray {
  int *val;  /* array of integers */
  int  len;  /* the length of the array */
  int  maxlen;  /* the length of the allocated array */
  int  minelem; /* for ep-mine-array.c: minimum element in the iarray */
} *Intarray;

/* Note: Intarray is a pointer to a struct. */

typedef
Intarray Intstack; 

/******************************************************************
 * Functions
 ******************************************************************/

//z^
extern Intarray ia_alloc(int len);
extern void ia_free(Intarray temp);

extern void ia_make_null(Intarray tmp); 
extern void ia_realloc(Intarray ia, int size); 
extern void ia_assert_defined(Intarray ia); 

//ЂƂǉ
extern void ia_push_back(Intarray ia, int x); 

extern void ia_copy(Intarray ia, Intarray ib); 
extern void ia_ncopy(Intarray ia, Intarray ib, int len); 
extern void ia_copy_slice(Intarray ia, Intarray ib, int beg, int end); 
extern void ia_fill_inc(Intarray ia, int len); 
extern void ia_fill_random(Intarray ia, int range, int len); 
extern void ia_append(Intarray ia, Intarray ib); 

extern int  ia_last_val(Intarray ia); 
extern int  ia_is_equal(Intarray ia, Intarray ib); 

extern void ia_print(Intarray ia);
extern void ia_print_nl(); 
extern void ia_report(Intarray ia); 
extern void ia_report_colwidth(Intarray ia, int colwidth); 

//͂ȂB

/* Disk I/O */
extern int ia_write_disk(Intarray ia, char *outname); 
extern int ia_read_disk(Intarray ia, char *inname); 
extern int ia_veryfy_disk(Intarray ia, char *file_name); 

/* Counting */
extern void ia_map(Intarray ia, Intarray ib); 
extern void ia_int_sort(Intarray ia); 
extern void ia_uniq(Intarray ia); 
extern void ia_uniq_ordered(Intarray ia); 
extern void ia_count(Intarray ia, Intarray count, int num_labels); 
extern void ia_scalar_add(Intarray ia, int x); 
extern void ia_fill(Intarray ia, int len, int x); 

/* Stack */
extern Intstack ia_stack_alloc(void);
extern void ia_stack_free(Intstack tmp);
extern void ia_push(Intstack ia, int x);
extern int ia_pop(Intstack ia);
extern int ia_top(Intstack ia);
extern int ia_is_empty(Intstack ia);

/* Interface to C-int-array */
extern Intarray ia_append_append(Intarray ia, int *array, int len); 
extern Intarray ia_copy_array(Intarray ia, int *array, int len); 
extern void ia_write_to_array(Intarray ia, int *array, int len); 

/******************************************************************
 * Comments
 ******************************************************************/

#endif

