/******************************************************************
 * ep-database.c
 * - nf[^x[XƃGs\[hCoXg̋ʕ
 * - Created on 14 FEB 2004 by {arim,y-uchida}@i.kyushu-u.ac.jp
 *   based on ep-approx-list.c 
 * - Created on 14 FEB 2004 by arim@i.kyushu-u.ac.jp
 *   based on ep-approx-list-all2.c 
 * - ep-approx-list-all2.c: 
 *   Created on 4 FEB 2004 by {uchida,arim}@i.kyushu-u.ac.jp.
 *   based on ep-approx-list-all.c 
 * $Id: ep-database.c,v 1.4 2004/02/25 20:31:59 arim Exp $
 ******************************************************************/

#include <assert.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <math.h>
#include "ap-util.h"
#include "ap-carray.h"
#include "ap-iarray.h"
#include "ep-mine-api.h"

/******************************************************************
 * Global: Public
 ******************************************************************/

#undef DEBUG 

//Statistics
int np[MAXLEN_PATTERN];
int npsum[MAXLEN_PATTERN];
int npsqr[MAXLEN_PATTERN];

//Number of pattern found
int   pattern_id = 0;
void 	episode_init() {
	pattern_id = 0;
}

int db_num_chars = 0;
int db_num_seqs  = 0;
Intarray es_freq = NULL;

/******************************************************************
 * Global: Private
 ******************************************************************/


/******************************************************************
 * Procedures
 ******************************************************************/

//Reading lines into a database from a stdin, and 
//returns the database
Database db_read()
{
  Intarray database;
  db_num_chars = 0;
  int curr = 0; 

  Line line, tmp_line; 
  char c;
  int i; 
  
  database = ia_alloc(0);

  while ((c = getchar()) != EOF) {

	db_num_chars++; /* the number of letters in the input file*/

    if (c == '\n') {
      curr++; 
    }

    if (curr >= database->len ) {
      tmp_line = ca_alloc(0); //empty line
      ia_push_back(database, (int) tmp_line);
    }

    if (c == '\n') {
      continue;
    }

#ifdef DEBUG
	printf("%c ", c);
#endif
		if (32 <= c && c <= 126) {
			line = (Line) database->val[curr];
			ca_push_back(line, c);
		}
  } //while

  if (((Line)(database->val[(database->len) - 1]))->len == 0)
    database->len = database->len - 1;

  return database; 
}

void db_print(Database database)
{
  int curr = 0, i; 
  Charray line; 
  char c;

  for (curr = 0; curr < database->len; curr++) {
    line = (Charray) database->val[curr];
    printf("##line %d: ", curr);
    for (i = 0; i < line->len; i++) {
      c = line->val[i];
      putchar(c);
    }
    printf("\n");
  }
}

int db_get_num_chars(Database database) {
	return db_num_chars;
}

int db_get_num_seqs(Database database) {
	return database->len;
}

void es_print(Eventset eventset)
{
  int i; 
  char c;

  printf("eventset: %d (events)\t[", eventset->len);
  for (i = 0; i < eventset->len; i++) {
    c = eventset->val[i];
    putchar(c);
    //putchar(' ');
  }
  printf("]\n");
}

int make_eo(Eventset eventset, Database database)
{
  int i, j, k;
  char c;
  Eventoccdb eventoccdb;
  Occdb occdb, occ, eoccdb;
  Line line;

  eventoccdb = ia_alloc(0);

  for (i = 0; i < eventset->len; i++){
    c = eventset->val[i];
    occdb = ia_alloc(0);
    for (j = 0; j < database->len; j++){
      line = (Line) database->val[j];
      occ = ia_alloc(0);
      for (k = 0; k < line->len; k++){
	if (line->val[k] == c){
	  ia_push_back(occ, k);
	}
      }
      ia_push_back(occdb, (int) occ);
    }
    ia_push_back(eventoccdb, (int) occdb);
  }

	//Precomputing es_freq
	es_freq = ia_alloc(eventoccdb->len);
	for (i = 0; i < eventoccdb->len; i++) {
    eoccdb = (Occdb) eventoccdb->val[i];
		es_freq->val[i] = count_freq(eoccdb); //pruning
	}

  return (int) eventoccdb;
}

Eventset make_es(Database database)
{
  int curr = 0, i, j; 
  Line line;
  Eventset eventset;
  char c;

  eventset = ca_alloc(0);

  for (curr = 0; curr < database->len; curr++) {
    line = (Line) database->val[curr];
    for (i = 0; i < line->len; i++) {
      c = line->val[i];
      for (j = 0; j < eventset->len; j++) {
				if (c == eventset->val[j]) break;
      }
      if (c != eventset->val[j]) {
				ca_push_back(eventset, c);
      }
    }
  }

  return eventset;
}

/*
 * Utilities
 */

#ifdef USE_MINSCORE
void episode_print_header() {  printf(
		 "id\tpattern\tdocFreq\tscanLen\taveScr\tmax:minScr\n");	}
#else
void episode_print_header() {  printf("id\tpattern\tdocFreq\tscanLen\n");	}
#endif

void epsode_print(Episode episode, int docfreq, int mofreq) {
	if (!ENABLE_PRINT_PATTERN){
		pattern_id++;// no print ł#total pattern num o 15Feb04
		return;
	}
  printf("%d\t[", pattern_id++);
  ca_print(episode);
  printf("]\t%d\t%d\n", docfreq, mofreq);
}

/* modified by arim: for minscore and avrscore version*/
void epsode_print(Episode episode, int docfreq, int mofreq,
									float avrscore, int max_k, int min_k) {
	if (!ENABLE_PRINT_PATTERN){
		pattern_id++;// no print ł#total pattern num o 15Feb04
		return;
	}
  printf("%d\t[", pattern_id++);
  ca_print(episode);
  printf("]\t%d\t%d\t%d - %.2f - %d\n", docfreq, mofreq, max_k, avrscore, min_k);
}

/* pattern_stat: */

void init_pattern_stat() {
	int i;
	for (i = 0; i < MAXLEN_PATTERN; i++) {
		np[i] = 0;
		npsum[i] = 0;
	}
}

void print_pattern_stat() {
	int i;
	printf("#pattern statistics: \n#len\tnumber\tfreqAve\tfreqVar\n");
	for (i = 0; i < MAXLEN_PATTERN; i++) {
		if (np[i] == 0) break;
		double _avefreq =
			(npsum[i]/(double)np[i]);  //Note: why *0.5?  //Average
		double _varfreq =
			sqrt((npsqr[i]/(double)np[i]) - (_avefreq * _avefreq)); //Variance
		printf("%d\t%d\t%.2f\t%.3f\n",
					 i , np[i], (double)_avefreq, (double)_varfreq);
	}
}

int count_freq(Intarray occdb) {
	int freq = 0, i;
	Occdb occ;
  for (i = 0; i < occdb->len; i++){
    occ = (Occdb) occdb->val[i];
    if (occ->len != 0) {
      freq++;
    }
  }
	return freq;
}

/* EOF */
