/* ep-mine-api.h
 * Header file for ep-approx-list.c
 */

#ifndef INCLUDED_EP_COMMON
#define INCLUDED_EP_COMMON

#define INTMAX (256*256)
#define TRUE  (1)
#define FALSE (0)

//extern int USEINS;
//extern int USEDEL;
//extern int USEEX ;

extern int MAXINS;
extern int MAXDEL;
extern int MAXEX;
extern int DELTA_WIN; 
extern int ENABLE_PRINT_PATTERN;
extern int WINDOW_FREE;

#define MAXLEN_PATTERN (100)
extern int np[MAXLEN_PATTERN];
extern int npsum[MAXLEN_PATTERN];
extern int npsqr[MAXLEN_PATTERN];

extern Intarray es_freq; //for pruning

//œK
#define MAX_IARRAY (0)
#define IA_MARGIN (10)

//ŏl}
#define USE_MINSCORE

/* Types */

typedef Intarray
Database;

typedef Charray
Eventset;

typedef Charray
Episode;

typedef Intarray
Occdb;

typedef Charray
Line;

typedef Intarray
Eventoccdb;

/* General variables*/
extern char filename[128];
extern int   minsup; 	/* minimum support in */
extern float minsup_percent; 	/* minimum support in percent */
extern int   maxscore;                /* maximum edit distance */
extern int   minscore;                /* minimum edit distance */
extern int   k;                /* Only for compatibility */

/* Working */
extern int  pattern_id;
//extern int np[];
//extern int npsum[];


/* Procedures */
extern Database db_read();
extern void db_print(Database database);
extern int db_get_num_chars(Database database);
extern int db_get_num_seqs(Database database);

extern void es_print(Eventset eventset);
extern Eventset make_es(Database database);
extern int make_eo(Eventset eventset, Database database);

extern void	episode_init(); 
extern void episode_print_header();
extern void epsode_print(Episode episode, int docfreq, int mofreq);
extern void epsode_print(Episode episode, int docfreq, int mofreq, float avrscore, int max_k, int min_k);
extern void episode_mine(Eventset es, Database db, int minsup, int k);
extern void episode_mine_skip(Eventset eventset, Database database, Eventoccdb eventoccdb, int minsup, int w);

extern void init_pattern_stat();
extern void print_pattern_stat();

extern int count_freq(Intarray occdb);

#endif
/* EOF */
