/******************************************************************
 * ep-mine-app-list.c
 * - n񔭌葱FõXg
 * - Created on 14 FEB 2004 by {arim,y-uchida}@i.kyushu-u.ac.jp
 *   based on ep-approx-list-all2.c 
 * - ep-approx-list-all2.c: 
 *   Created on 4 FEB 2004 by {uchida,arim}@i.kyushu-u.ac.jp.
 *   based on ep-approx-list-all.c 
 * $Id: ep-mine-app-list.c,v 1.1 2004/02/14 13:28:10 arim Exp $
 ******************************************************************/

#include "ap-util.h"
#include "ap-carray.h"
#include "ap-iarray.h"
#include <assert.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "ep-mine-api.h"

/*
 * Search: Algorithm Specific Part
 */

int update(char e, Occdb occ, Line line, int maxk)
{
  int i;
  int k;
  int pos;
  int next;
  int M, N;
  int INS, EX, DEL;
  Occdb newocc;
  bool flag;

  M = occ->len;
  N = line->len;
  newocc = ia_alloc(line->len + IA_MARGIN);

  k = INTMAX;
  for (i = 0; i < M; i = i+2) {
		if (i == M-2) {
      next = N;
		} else {
      next = occ->val[i+2];
		}

		pos = occ->val[i];
		DEL = occ->val[i+1] + MAXDEL;//gamma(a->epsilon)
		k = (k < DEL) ? k: DEL;
		if (k <= maxk) {
			ia_push_back(newocc, pos);
			ia_push_back(newocc, k);
		}
		if (e == line->val[pos+1]) {
			EX = occ->val[i+1];//gamma(a->a)=0
		} else {
			EX = occ->val[i+1] + MAXEX;//gamma(a->b)
		}
		INS = k + MAXINS;//gamma(epsilon->b)//org

		k = (EX < INS) ? EX: INS;

		pos++;
		while (pos < next) {
			if (k <= maxk) {
				ia_push_back(newocc, pos);
				ia_push_back(newocc, k);
			} else {
				k = INTMAX;
				break;
			}
			k = k + MAXINS;//gamma(epsilon->b)
			pos++;
		}
	}
  return (int) newocc;
}

void expand(Episode episode, Eventset eventset, Occdb occdb, Database database, int minsup, int maxscore)
{
  int i, j;
  int freq = 0, np_freq = 0;
  Episode newepisode;
  Occdb   newoccdb;
  Occdb   occ, newocc;
  Line    line;
  
  for (i = 0; i < occdb->len; i++){
    occ = (Occdb) occdb->val[i];
    if (occ->len != 0) {
      freq++;
			np_freq += occ->len;
    }
  }
  if (freq < minsup) {
    ca_free(episode);
    for (i = 0; i < occdb->len; i++) {
      occ = (Occdb) occdb->val[i];
      ia_free(occ);
    }
    ia_free(occdb);
    return;
  }

	//Process pattern
	np_freq = (int)(np_freq*0.5); //modified by arim
	epsode_print(episode, freq, np_freq);
	np[episode->len]++;
	npsum[episode->len] += freq; //document frequecy
	npsqr[episode->len] += freq * freq; //sqr of document frequecy

  for (i = 0; i < eventset->len; i++) {
    newepisode = ca_alloc(0);
    newoccdb = ia_alloc(database->len + IA_MARGIN);
    ca_copy(newepisode, episode);
    ca_push_back(newepisode, eventset->val[i]);
    for (j = 0; j < database->len; j++) {
      line = (Line) database->val[j];
      occ = (Occdb) occdb->val[j];
      if (occ->len != 0){
        newocc = (Occdb) update(eventset->val[i], occ, line,
																maxscore - DELTA_WIN);
				ia_push_back(newoccdb, (int) newocc);
      } else{
        newocc = ia_alloc(0); //󃊃Xg
				ia_push_back(newoccdb, (int) newocc);
      }
    }
		expand(newepisode, eventset, newoccdb, database, minsup,
					 maxscore - DELTA_WIN);
  }
  free(episode);
  for (i = 0; i < occdb->len; i++) {
    occ = (Occdb) occdb->val[i];
    ia_free(occ);
  }
  ia_free(occdb);
}

void episode_mine(Eventset eventset, Database database, int minsup, int maxscore)
{
  Occdb occdb;
  Occdb occ;
  Episode episode;
  Line line;
  int i, j;

  episode = ca_alloc(0);
  occdb = ia_alloc(database->len + IA_MARGIN);
  
  for (i = 0; i < database->len; i++) {
    line = (Line) database->val[i];
    occ = ia_alloc(line->len + IA_MARGIN);
    for (j = 0; j <= line->len; j++) {
      ia_push_back(occ, j-1);
      ia_push_back(occ, 0);
    }
    ia_push_back(occdb, (int) occ);
  }

  expand(episode, eventset, occdb, database, minsup, maxscore);
}


/* EOF */

