/******************************************************************
 * ep-mine-app-naive.c
 * - n񔭌葱FfpȔ
 *   p^[𐶐CIv@Ńp^[ƍ. 
 * - Created on 14 FEB 2004 by {arim,y-uchida}@i.kyushu-u.ac.jp
 *   based on ep-approx-list-all2.c 
 * - ep-approx-list-all2.c: 
 *   Created on 4 FEB 2004 by {uchida,arim}@i.kyushu-u.ac.jp.
 *   based on ep-approx-list-all.c 
 * $Id: ep-mine-app-naive.c,v 1.1 2004/02/14 13:28:10 arim Exp $
 ******************************************************************/

#include "ap-util.h"
#include "ap-carray.h"
#include "ap-iarray.h"
#include <assert.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "ep-mine-api.h"

/*
 * Search: Algorithm Specific Part
 */
#define min3(A, B, C) (A < B) ? ((A < C) ? A : C) : ((B < C) ? B : C)

int update(Episode episode, Line line, int k)
{
  int i, j;
  int M, N;
  int REP, INS, DEL, ED;
  int *occ;
	int flag = 0;

  M = line->len;
	N = episode->len;

  occ = (int *) malloc(sizeof(int) * (N + 1) * (M + 1));

	for (j = 0; j < M + 1; j++) {
		*(occ + (0 * (M+1) + j)) = 0;
	}

	for (i = 1; i < N + 1; i++) {
		*(occ + (i * (M+1) + 0)) = *(occ + ((i-1) * (M+1) + 0)) + MAXDEL; //gamma(e->epsilon)
		for (j = 1; j < M + 1; j++) {
			if (line->val[j-1] == episode->val[i-1]){
				*(occ + (i * (M+1) + j)) = *(occ + ((i-1) * (M+1) + j-1));
			} else {
				REP = *(occ + ((i-1) * (M+1) + j-1)) + MAXEX;            //gamma(e->x)
				INS = *(occ + (i * (M+1) + j-1)) + MAXINS;                //gamma(epsilon->x)
				DEL = *(occ + ((i-1) * (M+1) + j)) + MAXDEL;              //gamma(e->epsilon)

				ED = min3(REP, INS, DEL);      //ED=minimum(REP,INS,DEL)

				*(occ + (i * (M+1) + j)) = ED;
			}
		}
	}

	for (j = 0; j < M + 1; j++) {
		if (*(occ + (N * (M+1) + j)) <= k) {
			flag = 1;
			break;
		}
	}

	free(occ);
  return flag;
}

void expand(Episode episode, Eventset eventset, Occdb occdb, Database database, int minsup, int k)
{
  int     i, j;
  int freq = 0, np_freq = 0;
  Episode newepisode;
  Occdb   newoccdb;
  Occdb   occ, newocc;
  Line    line;

  for (i = 0; i < occdb->len; i++){
    occ = (Occdb) occdb->val[i];
		if (occ->val[0] == 1) {
      freq++;
      line = (Line) database->val[i];
			np_freq += ((line->len + 1) * (episode->len + 1));
			//the amount of scan: the width times length of the DP table
		}
  }

  //printf("freq = %d\n", freq);
  if (freq < minsup) {
		ca_free(episode);
		for (i = 0; i < occdb->len; i++){
			occ = (Occdb) occdb->val[i];
			ia_free(occ);
		}
		ia_free(occdb);
    return;
  }

	//Process pattern
	np_freq = (int)(np_freq*1.0); //modified by arim
	epsode_print(episode, freq, np_freq);
	np[episode->len]++;
	npsum[episode->len] += freq; //document frequecy
	npsqr[episode->len] += freq * freq; //sqr of document frequecy

  for (i = 0; i < eventset->len; i++) {
    newepisode = ca_alloc(0);
    newoccdb = ia_alloc(database->len + IA_MARGIN);
    ca_copy(newepisode, episode);
    ca_push_back(newepisode, eventset->val[i]);
    for (j = 0; j < database->len; j++) {
      line = (Line) database->val[j];
			newocc = ia_alloc(line->len + IA_MARGIN);
			ia_push_back(newocc, update(newepisode, line, k - DELTA_WIN));
			ia_push_back(newoccdb, (int) newocc);
    }
    expand(newepisode, eventset, newoccdb, database, minsup, k - DELTA_WIN);
  }

	ca_free(episode);
	for (i = 0; i < occdb->len; i++){
		occ = (Occdb) occdb->val[i];
		ia_free(occ);
	}
	ia_free(occdb);
}

void episode_mine(Eventset eventset, Database database, int minsup, int k)
{
  Occdb   occdb;
  Occdb   occ;
  Episode episode;
  Line    line;
  int     i, j;

  episode = ca_alloc(0);
  occdb = ia_alloc(database->len + IA_MARGIN);

  for (i = 0; i < database->len; i++) {
		occ = ia_alloc(0);
    ia_push_back(occ, 1);
    ia_push_back(occdb, (int) occ);
  }

  expand(episode, eventset, occdb, database, minsup, k);
}



/* EOF */

